Option Strict Off
Option Explicit On
Module TUSBADMH
	'*******   High speed A/D converter TUSB-0216ADMH   ******
	'         Control Module File for Visual Basic
	
	Declare Sub Tusbadmh_Load Lib "TUSBADMH.DLL" ()
	Declare Sub Tusbadmh_Unload Lib "TUSBADMH.DLL" ()
	Declare Function Tusbadmh_Chk Lib "TUSBADMH.DLL" (ByVal Id As Short) As Short
	Declare Function Tusbadmh_Dio_Read Lib "TUSBADMH.DLL" (ByVal Id As Short, ByRef Data As Byte) As Short
	Declare Function Tusbadmh_Dio_Write Lib "TUSBADMH.DLL" (ByVal Id As Short, ByVal Data As Byte) As Short
	Declare Function Tusbadmh_Adc_Start Lib "TUSBADMH.DLL" (ByVal Id As Short, ByVal CycLen As Integer, ByVal PreLen As Integer, ByVal TrgSel As Byte, ByVal Mode As Byte, ByVal Ch1Only As Byte) As Short
	Declare Function Tusbadmh_Adc_Stop Lib "TUSBADMH.DLL" (ByVal Id As Short) As Short
	Declare Function Tusbadmh_Status_Get Lib "TUSBADMH.DLL" (ByVal Id As Short, ByRef Status As Byte, ByRef OvfSt As Byte) As Short
	Declare Function Tusbadmh_Length Lib "TUSBADMH.DLL" (ByVal Id As Short, ByRef Len1 As Integer, ByRef Len2 As Integer, ByRef Rate1 As Integer, ByRef Rate2 As Integer) As Short
	Declare Function Tusbadmh_Data_Get Lib "TUSBADMH.DLL" (ByVal Id As Short, ByVal ch As Byte, ByRef Data As Integer, ByRef Leng As Integer) As Short
	Declare Function Tusbadmh_Clock_Select Lib "TUSBADMH.DLL" (ByVal Id As Short, ByVal ClkSel As Byte, ByVal Div As Byte, ByVal Ave As Byte) As Short
	Declare Function Tusbadmh_ThLevel_Set Lib "TUSBADMH.DLL" (ByVal Id As Short, ByVal ThLevel As Integer, ByVal NLevel As Integer) As Short
	Declare Function Tusbadmh_InputType Lib "TUSBADMH.DLL" (ByVal Id As Short, ByVal Type1 As Byte, ByVal Type2 As Byte) As Short
	Declare Function Tusbadmh_CheckInputType Lib "TUSBADMH.DLL" (ByVal Id As Short, ByRef Type1 As Byte, ByRef Type2 As Byte) As Short
	Declare Function Tusbadmh_Trigger Lib "TUSBADMH.DLL" (ByVal Id As Short) As Short
	
	'Tusbadmh_Clock_Select
	
	' Error Message
	Public Function Tusbadmh_ErrorDisp(ByVal ErrCode As Short) As Object
		Dim tmpStr As String
		
        Select Case ErrCode
            Case 0
                tmpStr = "ɏI܂"
            Case 1
                tmpStr = "IDԍ܂"
            Case 2
                tmpStr = "hCoĂ܂"
            Case 4
                tmpStr = "ڑĂ䐔܂"
            Case 5
                tmpStr = "I[vł܂ł"
            Case 6
                tmpStr = "foCX܂ł"
            Case 7
                tmpStr = "w̃foCX̓I[vĂ܂"
            Case 8
                tmpStr = "p[^G["
            Case 9
                tmpStr = "USBʐMG["
            Case 10
                tmpStr = "̈悪mۂł܂"
            Case 11
                tmpStr = "A捞쒆ł"
            Case 12
                tmpStr = "A荞݃f[^͂܂"
            Case 13
                tmpStr = "JnĂ܂"
            Case 14
                tmpStr = "I[o[t["
            Case 15
                tmpStr = "f[^уG["
            Case Else
                tmpStr = "sȃG[ł"
        End Select

        MsgBox(tmpStr)
	End Function
End Module