// DevForm.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "ADMHSample.h"
#include "DevForm.h"
#include "TUSBADMH.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TIMER1	1//Ď^C}[
#define TIMER2	2//ADϊL^^C}[

/////////////////////////////////////////////////////////////////////////////
// CDevForm _CAO


CDevForm::CDevForm(CWnd* pParent /*=NULL*/)
	: CDialog(CDevForm::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDevForm)
	m_DOChk0 = FALSE;
	m_DOChk1 = FALSE;
	m_DOChk2 = FALSE;
	m_DOChk3 = FALSE;
	m_DivideN = 0;
	m_IntClkFreq = _T("");
	m_Ch1InputSel = -1;
	m_Ch2InputSel = -1;
	m_TrgSel = -1;
	m_ThLevel = 0;
	m_NcLevel = 0;
	m_ThLevelV = _T("");
	m_NcLevelV = _T("");
	m_CycleLen = 0;
	m_PreTrgLen = 0;
	m_TotalLen = 0;
	m_SmplMode = -1;
	m_Ch1Only = FALSE;
	m_ClockSrc = -1;
	m_AverageN = -1;
	//}}AFX_DATA_INIT
}


void CDevForm::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDevForm)
	DDX_Control(pDX, IDC_AVERAGE_N, m_AverageNBox);
	DDX_Control(pDX, IDC_CLOCK_SRC, m_ClockSrcBox);
	DDX_Control(pDX, IDC_CH2_INPUTSEL1, m_Ch2InputSelBtn1);
	DDX_Control(pDX, IDC_CH2_INPUTSEL2, m_Ch2InputSelBtn2);
	DDX_Control(pDX, IDC_CH1_ONLY, m_Ch1OnlyBtn);
	DDX_Control(pDX, IDC_SMPL_MODE1, m_SmplModeBtn1);
	DDX_Control(pDX, IDC_SMPL_MODE2, m_SmplModeBtn2);
	DDX_Control(pDX, IDC_TRGSEL1, m_TrgSelBtn1);
	DDX_Control(pDX, IDC_TRGSEL2, m_TrgSelBtn2);
	DDX_Control(pDX, IDC_TRGSEL3, m_TrgSelBtn3);
	DDX_Control(pDX, IDC_TRGSEL4, m_TrgSelBtn4);
	DDX_Control(pDX, IDC_CH1_INPUTSEL1, m_Ch1InputSelBtn1);
	DDX_Control(pDX, IDC_CH1_INPUTSEL2, m_Ch1InputSelBtn2);
	DDX_Control(pDX, IDC_CH2_BUF_RATE, m_Ch2BufRate);
	DDX_Control(pDX, IDC_CH1_BUF_RATE, m_Ch1BufRate);
	DDX_Control(pDX, IDC_CH2_SAMPLED_LENG, m_Ch2SampledLen);
	DDX_Control(pDX, IDC_CH1_SAMPLED_LENG, m_Ch1SampledLen);
	DDX_Control(pDX, IDC_STATUS_DISP, m_StatusDisp);
	DDX_Control(pDX, IDC_FILE_CONV, m_FileConvBtn);
	DDX_Control(pDX, IDC_START_STOP, m_StartStopBtn);
	DDX_Control(pDX, IDC_TOTAL_LENG, m_TotalLenBox);
	DDX_Control(pDX, IDC_PRE_TRG_LENG, m_PreTrgLenBox);
	DDX_Control(pDX, IDC_CYCLE_LENG, m_CycleLenBox);
	DDX_Control(pDX, IDC_TRIGGER, m_TrgBtn);
	DDX_Control(pDX, IDC_NC_LEVEL, m_NcLevelBox);
	DDX_Control(pDX, IDC_TH_LEVEL, m_ThLevelBox);
	DDX_Control(pDX, IDC_DIVIDE_N, m_DivideNBox);
	DDX_Control(pDX, IDC_DOCHK3, m_DOChkBtn3);
	DDX_Control(pDX, IDC_DOCHK2, m_DOChkBtn2);
	DDX_Control(pDX, IDC_DOCHK1, m_DOChkBtn1);
	DDX_Control(pDX, IDC_DOCHK0, m_DOChkBtn0);
	DDX_Control(pDX, IDC_DIDISP3, m_DIDisp3);
	DDX_Control(pDX, IDC_DIDISP2, m_DIDisp2);
	DDX_Control(pDX, IDC_DIDISP1, m_DIDisp1);
	DDX_Control(pDX, IDC_DIDISP0, m_DIDisp0);
	DDX_Check(pDX, IDC_DOCHK0, m_DOChk0);
	DDX_Check(pDX, IDC_DOCHK1, m_DOChk1);
	DDX_Check(pDX, IDC_DOCHK2, m_DOChk2);
	DDX_Check(pDX, IDC_DOCHK3, m_DOChk3);
	DDX_Text(pDX, IDC_DIVIDE_N, m_DivideN);
	DDX_Text(pDX, IDC_INT_CLK_FREQ, m_IntClkFreq);
	DDX_Radio(pDX, IDC_CH1_INPUTSEL1, m_Ch1InputSel);
	DDX_Radio(pDX, IDC_CH2_INPUTSEL1, m_Ch2InputSel);
	DDX_Radio(pDX, IDC_TRGSEL1, m_TrgSel);
	DDX_Text(pDX, IDC_TH_LEVEL, m_ThLevel);
	DDX_Text(pDX, IDC_NC_LEVEL, m_NcLevel);
	DDX_Text(pDX, IDC_TH_LEVEL_V, m_ThLevelV);
	DDX_Text(pDX, IDC_NC_LEVEL_V, m_NcLevelV);
	DDX_Text(pDX, IDC_CYCLE_LENG, m_CycleLen);
	DDX_Text(pDX, IDC_PRE_TRG_LENG, m_PreTrgLen);
	DDX_Text(pDX, IDC_TOTAL_LENG, m_TotalLen);
	DDX_Radio(pDX, IDC_SMPL_MODE1, m_SmplMode);
	DDX_Check(pDX, IDC_CH1_ONLY, m_Ch1Only);
	DDX_CBIndex(pDX, IDC_CLOCK_SRC, m_ClockSrc);
	DDX_CBIndex(pDX, IDC_AVERAGE_N, m_AverageN);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDevForm, CDialog)
	//{{AFX_MSG_MAP(CDevForm)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_DOCHK0, OnDochk0)
	ON_BN_CLICKED(IDC_DOCHK1, OnDochk1)
	ON_BN_CLICKED(IDC_DOCHK2, OnDochk2)
	ON_BN_CLICKED(IDC_DOCHK3, OnDochk3)
	ON_EN_CHANGE(IDC_DIVIDE_N, OnChangeDivideN)
	ON_BN_CLICKED(IDC_TRGSEL1, OnTrgsel1)
	ON_BN_CLICKED(IDC_TRGSEL2, OnTrgsel2)
	ON_BN_CLICKED(IDC_TRGSEL3, OnTrgsel3)
	ON_BN_CLICKED(IDC_TRGSEL4, OnTrgsel4)
	ON_EN_CHANGE(IDC_TH_LEVEL, OnChangeThLevel)
	ON_BN_CLICKED(IDC_CH1_INPUTSEL1, OnCh1Inputsel1)
	ON_BN_CLICKED(IDC_CH1_INPUTSEL2, OnCh1Inputsel2)
	ON_BN_CLICKED(IDC_CH2_INPUTSEL1, OnCh2Inputsel1)
	ON_BN_CLICKED(IDC_CH2_INPUTSEL2, OnCh2Inputsel2)
	ON_EN_CHANGE(IDC_NC_LEVEL, OnChangeNcLevel)
	ON_BN_CLICKED(IDC_SMPL_MODE1, OnSmplMode1)
	ON_BN_CLICKED(IDC_SMPL_MODE2, OnSmplMode2)
	ON_BN_CLICKED(IDC_TRIGGER, OnTrigger)
	ON_BN_CLICKED(IDC_START_STOP, OnStartStop)
	ON_BN_CLICKED(IDC_FILE_CONV, OnFileConv)
	ON_CBN_EDITCHANGE(IDC_CLOCK_SRC, OnEditchangeClockSrc)
	ON_CBN_EDITCHANGE(IDC_AVERAGE_N, OnEditchangeAverageN)
	ON_CBN_SELCHANGE(IDC_CLOCK_SRC, OnSelchangeClockSrc)
	ON_CBN_SELCHANGE(IDC_AVERAGE_N, OnSelchangeAverageN)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDevForm bZ[W nh

void CDevForm::SetId(short Id)
{
	short retErr;
	BYTE IOData;
	char str[30];
	BYTE Type1;
	BYTE Type2;

	DevId = Id;

	UpdateData(TRUE);

	sprintf(str,"ID = %d  Panel",DevId);
	SendMessage(WM_SETTEXT,0,(LPARAM)str);

	retErr = Tusbadmh_Dio_Read(DevId, &IOData);//Read digital I/O
	if( retErr )
	{
		ErrorDisp(retErr);
		ShowWindow(SW_HIDE);
		return;
	}
	else
	{
		//Output state
		m_DOChk3 = ( IOData & 0x80 ) ? 1 : 0;
		m_DOChk2 = ( IOData & 0x40 ) ? 1 : 0;
		m_DOChk1 = ( IOData & 0x20 ) ? 1 : 0;
		m_DOChk0 = ( IOData & 0x10 ) ? 1 : 0;

		//Input State
		m_DIDisp3.SetWindowText(( IOData & 0x08 ) ? "High" : "Low" );
		m_DIDisp2.SetWindowText(( IOData & 0x04 ) ? "High" : "Low" );
		m_DIDisp1.SetWindowText(( IOData & 0x02 ) ? "High" : "Low" );
		m_DIDisp0.SetWindowText(( IOData & 0x01 ) ? "High" : "Low" );
	}

    retErr = Tusbadmh_CheckInputType(DevId, &Type1, &Type2);//Read input range
	if( retErr )
	{
		ErrorDisp(retErr);
		ShowWindow(SW_HIDE);
		return;
	}
	else
	{
		m_Ch1InputSel = ( Type1 == 1 ) ? 0 : 1;
		m_Ch2InputSel = ( Type2 == 1 ) ? 0 : 1;
	}

	m_ClockSrc = 0;
	m_AverageN = 0;
	m_DivideN = 8;
	m_TrgSel = 3;
	m_ThLevel = 32768;
	m_NcLevel = 1638;
	m_SmplMode = 1;
	m_CycleLen = 1000;
	m_PreTrgLen = 0;
	m_TotalLen = 100000;
	UpdateData(FALSE);

	OnChangeDivideN();
	OnCh1Inputsel1();
	OnCh2Inputsel1();
	OnChangeNcLevel();
	TrgSet();
	OnSmplMode2();

	SetTimer(TIMER1,100,NULL);
}

// timer handler
void CDevForm::OnTimer(UINT nIDEvent) 
{
	switch( nIDEvent )
	{
	case TIMER1:
		if( Tusbadmh_Chk(DevId) != 0 )
		{
			ShowWindow(SW_HIDE);
			KillTimer(TIMER1);
		}
		else
		{
			DI_Check();
		}
		break;
	case TIMER2:
		SamplingCheck();
		break;
	}
	CDialog::OnTimer(nIDEvent);
}

void CDevForm::DI_Check()
{
	BYTE IOData;
	short retErr;

	retErr = Tusbadmh_Dio_Read(DevId, &IOData);
	if( retErr )
	{
		ErrorDisp(retErr);
		KillTimer(TIMER1);
		ShowWindow(SW_HIDE);
	}
	else
	{
		//͏
		m_DIDisp3.SetWindowText((( IOData & 0x08 ) ? "High":"Low"));
		m_DIDisp2.SetWindowText((( IOData & 0x04 ) ? "High":"Low"));
		m_DIDisp1.SetWindowText((( IOData & 0x02 ) ? "High":"Low"));
		m_DIDisp0.SetWindowText((( IOData & 0x01 ) ? "High":"Low"));
	}
}

void CDevForm::ErrorDisp(short ErrCode)
{
	char str[50];

	switch( ErrCode )
	{
	case 0:
		strcpy(str,"ɏI܂");
		break;
	case 1:
		strcpy(str,"IDԍ܂");
		break;
	case 2:
		strcpy(str,"hCoĂ܂");
		break;
	case 4:
		strcpy(str,"ڑĂ䐔܂");
		break;
	case 5:
		strcpy(str,"I[vł܂ł");
		break;
	case 6:
		strcpy(str,"foCX܂ł");
		break;
	case 7:
		strcpy(str,"w̃foCX̓I[vĂ܂");
		break;
	case 8:
		strcpy(str,"p[^G[");
		break;
	case 9:
		strcpy(str,"USBʐMG[");
		break;
	case 10:
		strcpy(str,"̈悪mۂł܂");
		break;
	case 11:
		strcpy(str,"A捞쒆ł");
		break;
	case 12:
		strcpy(str,"A荞݃f[^͂܂");
		break;
	case 13:
		strcpy(str,"JnĂ܂");
		break;
	case 14:
		strcpy(str,"I[o[t[");
		break;
	case 15:
		strcpy(str,"f[^уG[");
		break;
	default:
		strcpy(str,"sȃG[ł");
		break;
	}
	MessageBox(str,"^[G[",MB_OK);
}

void CDevForm::OnDochk0() 
{
    DO_Set();
	m_DOChkBtn0.SetWindowText((m_DOChk0 ? "High" : "Low"));
}

void CDevForm::OnDochk1() 
{
    DO_Set();
	m_DOChkBtn1.SetWindowText((m_DOChk1 ? "High" : "Low"));
}

void CDevForm::OnDochk2() 
{
    DO_Set();
	m_DOChkBtn2.SetWindowText((m_DOChk2 ? "High" : "Low"));
}

void CDevForm::OnDochk3() 
{
    DO_Set();
	m_DOChkBtn3.SetWindowText((m_DOChk3 ? "High" : "Low"));
}

void CDevForm::DO_Set()
{
	short retErr;
	BYTE OutData;

	UpdateData(TRUE);

	OutData = 0;

	if( m_DOChk0 )//Bit 0
		OutData += 0x01;
	if( m_DOChk1 )//Bit 1
		OutData += 0x02;
	if( m_DOChk2 )//Bit 2
		OutData += 0x04;
	if( m_DOChk3 )//Bit 3
		OutData += 0x08;

	retErr = Tusbadmh_Dio_Write(DevId, OutData); //ݒ

	if( retErr )
	{
		ErrorDisp(retErr);
		KillTimer(TIMER1);
		ShowWindow(SW_HIDE);
	}
}

void CDevForm::OnChangeDivideN() 
{
	Check_ClockSetting();
}

void CDevForm::OnTrgsel1() 
{
	TrgSet();
}

void CDevForm::OnTrgsel2() 
{
	TrgSet();
}

void CDevForm::OnTrgsel3() 
{
	TrgSet();
}

void CDevForm::OnTrgsel4() 
{
	TrgSet();
}

void CDevForm::TrgSet()
{
	UpdateData(TRUE);
	m_ThLevelBox.EnableWindow( m_TrgSel == 1 || m_TrgSel == 2 );
	m_NcLevelBox.EnableWindow( m_TrgSel == 1 || m_TrgSel == 2 );
	m_TrgBtn.EnableWindow(( m_TrgSel == 3 ));
}

void CDevForm::OnChangeThLevel() 
{
	double Volt;
	int leng;
	leng = m_ThLevelBox.GetWindowTextLength();
	
	if( leng > 0 )
	{
		UpdateData(TRUE);

        if(m_ThLevel >= 1 && m_ThLevel <= 65534)
		{
			if( m_Ch1InputSel == 0 )//j|[ 0-2V
				Volt = 2.0 * m_ThLevel / 65536.0;
			else//oC|[
				Volt = 2.0 * m_ThLevel / 65536.0 - 1.0;
			m_ThLevelV.Format("%.3f[V]",Volt);
		}
		else
			m_ThLevelV = "";
		UpdateData(FALSE);
	}
}

void CDevForm::OnCh1Inputsel1() 
{
	SetInputType();
	OnChangeThLevel();
}

void CDevForm::OnCh1Inputsel2() 
{
	SetInputType();
	OnChangeThLevel();
}

void CDevForm::OnCh2Inputsel1() 
{
	SetInputType();
}

void CDevForm::OnCh2Inputsel2() 
{
	SetInputType();
}

//̓WI
void CDevForm::SetInputType()
{
	short retErr;
	BYTE sel1,sel2;

	UpdateData(TRUE);
	sel1 = ( m_Ch1InputSel == 0 ) ? 1 : 0;//0->oC|[  1->j|[
	sel2 = ( m_Ch2InputSel == 0 ) ? 1 : 0;//0->oC|[  1->j|[
	retErr = Tusbadmh_InputType(DevId, sel1, sel2);//Set input range
	if( retErr )
	{
		ErrorDisp(retErr);
		KillTimer(TIMER1);
		ShowWindow(SW_HIDE);
	}
}

void CDevForm::OnChangeNcLevel() 
{
	double Volt;
	int leng;
	leng = m_NcLevelBox.GetWindowTextLength();
	
	if( leng > 0 )
	{
		UpdateData(TRUE);
		if( m_NcLevel >= 0 && m_NcLevel <= 3277 )//͈͓ł邩
		{
			Volt = 2.0 * m_NcLevel / 65536.0 * 1000.0;
			m_NcLevelV.Format("%.1f[mV]",Volt);
		}
		else
			m_NcLevelV = "";
		UpdateData(FALSE);
	}
}

//s[g[hIꂽ
void CDevForm::OnSmplMode1() 
{
	m_CycleLenBox.EnableWindow(TRUE);
	m_PreTrgLenBox.EnableWindow(FALSE);
}

//A[hIꂽ
void CDevForm::OnSmplMode2() 
{
	m_CycleLenBox.EnableWindow(FALSE);
	m_PreTrgLenBox.EnableWindow(TRUE);
}

void CDevForm::OnTrigger() 
{
	short retErr;

	retErr = Tusbadmh_Trigger(DevId);
	if( retErr )
	{
		ErrorDisp(retErr);
		KillTimer(TIMER1);
		ShowWindow(SW_HIDE);
	}
}

//ϊJnA~{^
void CDevForm::OnStartStop() 
{
	CString tmpStr;

	m_StartStopBtn.GetWindowText(tmpStr);
	if( tmpStr == "Start" )//Jn̏ꍇ
	{
		if( SamplingStart() )
		{
			EnableDisableControl(FALSE);
			m_StartStopBtn.SetWindowText("Stop");
		}
    }
	else//~̏ꍇ
	{
		if( SamplingStop() )
		{
			EnableDisableControl(TRUE);
			m_StartStopBtn.SetWindowText("Start");
			m_StatusDisp.SetWindowText("");
		}
	}
}

//AϊJn
BOOL CDevForm::SamplingStart()
{
	short retErr;
	int CycLen;
	int PreLen;
	BYTE Mode;

	UpdateData(TRUE);

	//NbNݒ`FbN
	if( !ClockCheckAndSet() )
		return FALSE;

    //gKݒ`FbN
	if( !TriggerCheckAndSet() )
		return FALSE;
    
	//荞ݐ`FbN
	if( m_SmplMode == 0 )//s[g[h
	{
		if( m_CycleLen < 1 || m_CycleLen > 1048576 )
		{
			MessageBox("1gK̎荞ݒ͈͊Oł","ݒlG[",MB_OK);
			return FALSE;
		}
		CycLen = m_CycleLen;
		PreLen = 0;
		Mode = 1;
	}
	else//A[h
	{
		if( m_PreTrgLen < 0 || m_PreTrgLen > 1048576 )
		{
			MessageBox("vgK͈͊Oł","ݒlG[",MB_OK);
			return FALSE;
		}
		PreLen = m_PreTrgLen;
		CycLen = 0;
		Mode = 0;
	}

	if( m_TotalLen < 1 || m_TotalLen > 2000000000 )
	{
		MessageBox("ő荞ݒ͈͊Oł","ݒlG[",MB_OK);
		return FALSE;
	}

	//ۑt@CI[v
	OPENFILENAME ofn;
	char fn[MAX_PATH];
	int ret;

	do{
		fn[0] = '\0';
		ZeroMemory(&ofn,sizeof(ofn));
		ofn.lStructSize = sizeof(ofn);
		ofn.Flags = 0;
		ofn.lpstrFile = fn;
		ofn.nMaxFile = sizeof(fn);
		ofn.lpstrTitle = "ADM Ch1 ۑt@Cw";
		ofn.lpstrFilter = "oCiۑt@C (*.dat)\0*.dat\0\0";
		ofn.lpstrDefExt = "dat";
		ret = GetSaveFileName(&ofn);
		if( ret == 0 )
			return FALSE;
	}while(strlen(fn) == 0);

	h_SAVEFILE1 = CreateFile(fn,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL,NULL);// A file is opened.
	
	if( m_Ch1Only == 0 )
	{
		do{
			fn[0] = '\0';
			ZeroMemory(&ofn,sizeof(ofn));
			ofn.lStructSize = sizeof(ofn);
			ofn.Flags = 0;
			ofn.lpstrFile = fn;
			ofn.nMaxFile = sizeof(fn);
			ofn.lpstrTitle = "ADM Ch2 ۑt@Cw";
			ofn.lpstrFilter = "oCiۑt@C (*.dat)\0*.dat\0\0";
			ofn.lpstrDefExt = "dat";
			ret = GetSaveFileName(&ofn);
			if( ret == 0 )
				return FALSE;
		}while(strlen(fn) == 0);
		h_SAVEFILE2 = CreateFile(fn,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,
			FILE_ATTRIBUTE_NORMAL,NULL);// A file is opened.
	}

	//荞ݐݒ񏑂
	COleDateTime NowTime;
	DATE DateTime;//
	BYTE Type1;//ch1 1:j|[@0:oC|[
	BYTE Type2;//ch2 1:j|[@0:oC|[
	BYTE InCh;//̓`l
	DWORD stLeng;
	
	DateTime = DATE(NowTime.GetCurrentTime());
	Type1 = ( m_Ch1InputSel == 0 ) ? 1 : 0;
	Type2 = ( m_Ch2InputSel == 0 ) ? 1 : 0;
	TrgSel = m_TrgSel;

	InCh = 1; //`l1
	WriteFile(h_SAVEFILE1,&DateTime,sizeof(DateTime),&stLeng,NULL );//ݓ
	WriteFile(h_SAVEFILE1,&InCh,sizeof(InCh),&stLeng,NULL );//`l1
	WriteFile(h_SAVEFILE1,&ClkSrc,sizeof(ClkSrc),&stLeng,NULL );//NbN
	WriteFile(h_SAVEFILE1,&ClkDivN,sizeof(ClkDivN),&stLeng,NULL );//NbN
	WriteFile(h_SAVEFILE1,&SmplAve,sizeof(SmplAve),&stLeng,NULL );//TvOω
	WriteFile(h_SAVEFILE1,&Type1,sizeof(Type1),&stLeng,NULL );//ch1 1:j|[@0:oC|[
	WriteFile(h_SAVEFILE1,&TrgSel,sizeof(TrgSel),&stLeng,NULL );//gKI 0:O 1:オ 2: 3:\tgEFA
	WriteFile(h_SAVEFILE1,&Threshold,sizeof(Threshold),&stLeng,NULL );//AiOgK臒l
	WriteFile(h_SAVEFILE1,&NoiseCancel,sizeof(NoiseCancel),&stLeng,NULL );//mCYLZx
	WriteFile(h_SAVEFILE1,&Mode,sizeof(Mode),&stLeng,NULL );//荞ݓ샂[h 0:A 1:s[g
	WriteFile(h_SAVEFILE1,&CycLen,sizeof(CycLen),&stLeng,NULL );//1gK̎荞ݒ
	WriteFile(h_SAVEFILE1,&PreLen,sizeof(PreLen),&stLeng,NULL );//vgK

	if( m_Ch1Only == 0 )
	{
		InCh = 2; //`l2
		WriteFile(h_SAVEFILE2,&DateTime,sizeof(DateTime),&stLeng,NULL );//ݓ
		WriteFile(h_SAVEFILE2,&InCh,sizeof(InCh),&stLeng,NULL );//`l2
		WriteFile(h_SAVEFILE2,&ClkSrc,sizeof(ClkSrc),&stLeng,NULL );//NbN
		WriteFile(h_SAVEFILE2,&ClkDivN,sizeof(ClkDivN),&stLeng,NULL );//NbN
		WriteFile(h_SAVEFILE2,&SmplAve,sizeof(SmplAve),&stLeng,NULL );//TvOω
		WriteFile(h_SAVEFILE2,&Type2,sizeof(Type2),&stLeng,NULL );//ch1 0:j|[@1:oC|[
		WriteFile(h_SAVEFILE2,&TrgSel,sizeof(TrgSel),&stLeng,NULL );//gKI 0:O 1:オ 2: 3:\tgEFA
		WriteFile(h_SAVEFILE2,&Threshold,sizeof(Threshold),&stLeng,NULL );//AiOgK臒l
		WriteFile(h_SAVEFILE2,&NoiseCancel,sizeof(NoiseCancel),&stLeng,NULL );//mCYLZx
		WriteFile(h_SAVEFILE2,&Mode,sizeof(Mode),&stLeng,NULL );//荞ݓ샂[h 0:A 1:s[g
		WriteFile(h_SAVEFILE2,&CycLen,sizeof(CycLen),&stLeng,NULL );//1gK̎荞ݒ
		WriteFile(h_SAVEFILE2,&PreLen,sizeof(PreLen),&stLeng,NULL );//vgK
	}

	//ϊJn
	retErr = Tusbadmh_Adc_Start(DevId, CycLen, PreLen, TrgSel, Mode, (BYTE) m_Ch1Only);//ϊJn
	if( retErr )
	{
		ErrorDisp(retErr);
		KillTimer(TIMER1);
		ShowWindow(SW_HIDE);
		CloseHandle(h_SAVEFILE1);
		if( m_Ch1Only == 0 )
			CloseHandle(h_SAVEFILE2);
		return FALSE;
	}

	SavedDataNum[0] = 0;
	SavedDataNum[1] = 0;
	SetTimer(TIMER2,200,NULL);

	return TRUE;
}

//NbNݒl̃`FbNƐݒ
BOOL CDevForm::ClockCheckAndSet()
{
	short retErr;
	double tmpClk;

	UpdateData(TRUE);

	ClkSrc = m_ClockSrc;

	if( ClkSrc != 5 )//NbN
	{
		switch( ClkSrc )
		{
		case 0://200MHz
			tmpClk = 200.0;
			break;
		case 1://20.48MHz
			tmpClk = 20.48;
			break;
		case 2://16.384MHz
			tmpClk = 16.384;
			break;
		case 3://12.8MHz
			tmpClk = 12.8;
			break;
		case 4://1.92MHz
			tmpClk = 1.92;
			break;
		}
		ClkDivN = m_DivideN;
		tmpClk /= ClkDivN;
		if( tmpClk > 25.0 || tmpClk <= 1.0 )//NbN1`25MHzłȂ΂ȂȂ
		{
			AfxMessageBox("NbNݒ肪͈͊Oł");
			return FALSE;
		}
	}
	else//ONbN
	{
		ClkDivN = m_DivideN;
		if( ClkDivN > 25.0 || ClkDivN < 1.0 )//1`25
		{
			AfxMessageBox("NbNݒ肪͈͊Oł");
			return FALSE;
		}
	}

	SmplAve = m_AverageN;
    
    retErr = Tusbadmh_Clock_Select(DevId, ClkSrc, ClkDivN - 1, SmplAve);//NbNݒ
	if( retErr )
	{
		ErrorDisp(retErr);
		KillTimer(TIMER1);
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}

//gK`FbNƐݒ
BOOL CDevForm::TriggerCheckAndSet()
{
	short retErr;

	if( m_TrgSel == 1 || m_TrgSel == 2 )//AiOgK̏ꍇ
	{
		if( m_ThLevel < 1 || m_ThLevel > 65534 )//͈͂̊mF
		{
			MessageBox("AiOgKxݒ͈͂܂","ݒlG[",MB_OK);
			return FALSE;
		}
		Threshold = m_ThLevel;

		if( m_NcLevel < 0 || m_NcLevel > 3277 )//͈͂̊mF
		{
			MessageBox("mCYLZݒ͈͂܂","ݒlG[",MB_OK);
			return FALSE;
		}
		NoiseCancel = m_NcLevel;

		retErr = Tusbadmh_ThLevel_Set(DevId, Threshold, NoiseCancel);//XbVhxݒ
		if( retErr )
		{
			ErrorDisp(retErr);
			KillTimer(TIMER1);
			ShowWindow(SW_HIDE);
			return FALSE;
		}
	}
	else
	{
		Threshold = 0;
		NoiseCancel = 0;
	}

	return TRUE;
}

//ϊ̊Ď
void CDevForm::SamplingCheck()
{
	BYTE Status;
	BYTE OvfSt;
	int Leng[2];
	int UsableRate[2];

	//Xe[^X`FbN
	if( Tusbadmh_Status_Get(DevId, &Status, &OvfSt) == 0 )
	{
		switch( Status )
		{
		case 0://~
			m_StatusDisp.SetWindowText("");
			break;
		case 1://gKO
			m_StatusDisp.SetWindowText("Trigger waiting.");
			break;
		case 2://gK
			switch( OvfSt )
			{
			case 1://ch1I[ot[
				m_StatusDisp.SetWindowText("Ch1 buffer overflow.");
				break;
			case 2://ch2I[ot[
				m_StatusDisp.SetWindowText("Ch2 buffer overflow.");
				break;
			case 3://ch1Ch2I[ot[
				m_StatusDisp.SetWindowText("Ch1 && Ch2 buffer overflow.");
				break;
			default:
				m_StatusDisp.SetWindowText("Sampling");
				break;
			}
			break;
		}
	}

	//f[^荞
	int *Data;
	DWORD stLeng;
	CString tmpStr;

	if( Tusbadmh_Length(DevId, &Leng[0], &Leng[1], &UsableRate[0], &UsableRate[1]) == 0 )
	{
		if( ( SavedDataNum[0] + Leng[0] ) > m_TotalLen )//Ch1 f[^ꍇ
			Leng[0] = m_TotalLen - SavedDataNum[0];
		if( Leng[0] )
		{
			Data = new int[Leng[0]];
			if( Tusbadmh_Data_Get(DevId, 0, Data, &Leng[0]) == 0 )
				WriteFile(h_SAVEFILE1,Data,sizeof(int)*Leng[0],&stLeng,NULL );//f[^
			delete [] Data;
		}
		SavedDataNum[0] += Leng[0];

		if( m_Ch1Only == 0 )
		{
			if( ( SavedDataNum[1] + Leng[1] ) > m_TotalLen )//Ch2 f[^ꍇ
				Leng[1] = m_TotalLen - SavedDataNum[1];
			if( Leng[1] )
			{
				Data = new int[Leng[1]];
				if( Tusbadmh_Data_Get(DevId, 1, Data, &Leng[1]) == 0 )
					WriteFile(h_SAVEFILE2,Data,sizeof(int)*Leng[1],&stLeng,NULL );//f[^
				delete [] Data;
			}
			SavedDataNum[1] += Leng[1];
		}

		tmpStr.Format("%d",SavedDataNum[0]);
		m_Ch1SampledLen.SetWindowText(tmpStr);
		tmpStr.Format("%03d%%",UsableRate[0]);
		m_Ch1BufRate.SetWindowText(tmpStr);
		tmpStr.Format("%d",SavedDataNum[1]);
		m_Ch2SampledLen.SetWindowText(tmpStr);
		tmpStr.Format("%03d%%",UsableRate[1]);
		m_Ch2BufRate.SetWindowText(tmpStr);

		if( m_Ch1Only )
		{
			if( SavedDataNum[0] >= m_TotalLen )
				OnStartStop();//~
		}
		else
		{
			if( ( SavedDataNum[0] >= m_TotalLen) && ( SavedDataNum[1] >= m_TotalLen ) )
				OnStartStop();//~
		}
	}
}

//ϊ~
BOOL CDevForm::SamplingStop()
{
	short retErr;

	//ϊI
	KillTimer(TIMER2);

	retErr = Tusbadmh_Adc_Stop(DevId);//~

	CloseHandle(h_SAVEFILE1);
	if( m_Ch1Only == 0 )
		CloseHandle(h_SAVEFILE2);

	if( retErr )
	{
		ErrorDisp(retErr);
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}

void CDevForm::EnableDisableControl(BOOL Enable)
{
	m_AverageNBox.EnableWindow(Enable);
	m_ClockSrcBox.EnableWindow(Enable);
	m_DivideNBox.EnableWindow(Enable);
	m_Ch1InputSelBtn1.EnableWindow(Enable);
	m_Ch1InputSelBtn2.EnableWindow(Enable);
	m_Ch2InputSelBtn1.EnableWindow(Enable);
	m_Ch2InputSelBtn2.EnableWindow(Enable);
	m_TrgSelBtn1.EnableWindow(Enable);
	m_TrgSelBtn2.EnableWindow(Enable);
	m_TrgSelBtn3.EnableWindow(Enable);
	m_TrgSelBtn4.EnableWindow(Enable);
	m_ThLevelBox.EnableWindow(Enable);
	m_NcLevelBox.EnableWindow(Enable);
	m_SmplModeBtn1.EnableWindow(Enable);
	m_SmplModeBtn2.EnableWindow(Enable);
	m_TotalLenBox.EnableWindow(Enable);
	m_FileConvBtn.EnableWindow(Enable);
	m_Ch1OnlyBtn.EnableWindow(Enable);

	if( m_SmplMode == 0 )//JԂ[h
	{
		m_CycleLenBox.EnableWindow(Enable);
		m_PreTrgLenBox.EnableWindow(FALSE);
	}
	else
	{
		m_CycleLenBox.EnableWindow(FALSE);
		m_PreTrgLenBox.EnableWindow(Enable);
	}
}

//t@Cϊ@\
//poCit@CJ}؂eLXg`(CSV)ɕϊ
void CDevForm::OnFileConv() 
{
	HANDLE h_OPENFILE_B,h_SAVEFILE_T;
	OPENFILENAME ofnB,ofnT;
	char fnB[MAX_PATH],fnT[MAX_PATH];
	int ret;

	do{
		fnB[0] = '\0';
		ZeroMemory(&ofnB,sizeof(ofnB));
		ofnB.lStructSize = sizeof(ofnB);
		ofnB.Flags = 0;
		ofnB.lpstrFile = fnB;
		ofnB.nMaxFile = sizeof(fnB);
		ofnB.lpstrTitle = "oCit@Cw";
		ofnB.lpstrFilter = "oCit@C (*.dat)\0*.dat\0\0";
		ofnB.lpstrDefExt = "dat";
		ret = GetOpenFileName(&ofnB);
		if( ret == 0 )
			return;
	}while(strlen(fnB) == 0);


	do{
		fnT[0] = '\0';
		ZeroMemory(&ofnT,sizeof(ofnT));
		ofnT.lStructSize = sizeof(ofnT);
		ofnT.Flags = 0;
		ofnT.lpstrFile = fnT;
		ofnT.nMaxFile = sizeof(fnT);
		ofnT.lpstrTitle = "ϊt@Cw";
		ofnT.lpstrFilter = "eLXgۑt@C (*.csv)\0*.csv\0\0";
		ofnT.lpstrDefExt = "csv";
		ret = GetSaveFileName(&ofnT);
		if( ret == 0 )
			return;
	}while(strlen(fnT) == 0);

	h_OPENFILE_B = CreateFile(fnB,GENERIC_READ,0,NULL,OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,NULL);// A file is opened.
	
	h_SAVEFILE_T = CreateFile(fnT,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL,NULL);// A file is opened.

	//
	COleDateTime MeasTime;//
	DATE DateTime;//
	BYTE tmpByte;
	int tmpInt;
	DWORD stLeng;
	CString saveStr,tmpStr;

	ret = ReadFile(h_OPENFILE_B,&DateTime,sizeof(DateTime),&stLeng,NULL);//
	MeasTime = DateTime;
	saveStr = "\"Start date time\"," + MeasTime.Format("#%Y-%m-%d %H:%M:%S#\r\n");

	ReadFile(h_OPENFILE_B,&tmpByte,sizeof(tmpByte),&stLeng,NULL);//ch
	tmpStr.Format("\"Channel\",%d\r\n",tmpByte);
	saveStr += tmpStr;

 	ReadFile(h_OPENFILE_B,&tmpByte,sizeof(tmpByte),&stLeng,NULL);//NbNI
	saveStr += "\"Clock select\",";
	saveStr += ( tmpByte == 0 ) ? "\"200MHz\"\r\n" : 
				( tmpByte == 1 ) ? "\"20.48MHz\"\r\n" : 
				( tmpByte == 2 ) ? "\"16.384MHz\"\r\n" : 
				( tmpByte == 3 ) ? "\"12.8MHz\"\r\n" : 
				( tmpByte == 4 ) ? "\"1.92MHz\"\r\n" : 
				"\"External\"\r\n";

	ReadFile(h_OPENFILE_B,&tmpByte,sizeof(tmpByte),&stLeng,NULL);//NbN
	tmpStr.Format("\"Dividing rate\",%d\r\n",tmpByte);
	saveStr += tmpStr;

	ReadFile(h_OPENFILE_B,&tmpByte,sizeof(tmpByte),&stLeng,NULL);//TvOω搔
	tmpStr.Format("\"Average Cnt\",%d\r\n",(1<<tmpByte));
	saveStr += tmpStr;

	ReadFile(h_OPENFILE_B,&tmpByte,sizeof(tmpByte),&stLeng,NULL);//W 1:j|[@0:oC|[
	saveStr += "\"Input range\",";
	saveStr += (tmpByte == 1 ) ? "\"Unipolar\"\r\n" : "\"Bipolar\"\r\n";

	ReadFile(h_OPENFILE_B,&tmpByte,sizeof(tmpByte),&stLeng,NULL);//gKI 0:O 1:オ 2: 3:\tgEFA
	saveStr += "\"Trigger select\",";
	saveStr += ( tmpByte == 0 ) ? "\"External\"\r\n" : 
				( tmpByte == 1 ) ? "\"Up edge\"\r\n" : 
				( tmpByte == 2 ) ?  "\"Down edge\"\r\n" : "\"Software\"\r\n";


	ReadFile(h_OPENFILE_B,&tmpInt,sizeof(tmpInt),&stLeng,NULL);//AiOgK臒l
	tmpStr.Format("\"Trigger threshold\",%d\r\n",tmpInt);
	saveStr += tmpStr;

	ReadFile(h_OPENFILE_B,&tmpInt,sizeof(tmpInt),&stLeng,NULL);//mCYLZx
	tmpStr.Format("\"Noise cancel level\",%d\r\n",tmpInt);
	saveStr += tmpStr;

	ReadFile(h_OPENFILE_B,&tmpByte,sizeof(tmpByte),&stLeng,NULL);//荞ݓ샂[h 0:A 1:s[g
	saveStr += "\"Sampling mode\",";
	saveStr += (tmpByte == 0 ) ? "\"Continuation\"\r\n" : "\"Repeat\"\r\n";

	ReadFile(h_OPENFILE_B,&tmpInt,sizeof(tmpInt),&stLeng,NULL);//1gK̎荞ݒ
	tmpStr.Format("\"Sampling length per one trigger\",%d\r\n",tmpInt);
	saveStr += tmpStr;

	ReadFile(h_OPENFILE_B,&tmpInt,sizeof(tmpInt),&stLeng,NULL);//vgK
	tmpStr.Format("\"Pre trigger length\",%d\r\n",tmpInt);
	saveStr += tmpStr;

	if( stLeng )
		WriteFile(h_SAVEFILE_T,saveStr,saveStr.GetLength(),&stLeng,NULL);

    do{
		saveStr = "";
		for( int i = 0 ; i < 1000 ; i++ )
		{
			ReadFile(h_OPENFILE_B,&tmpInt,sizeof(tmpInt),&stLeng,NULL);//f[^
			if( stLeng == 0 )
				break;
			tmpStr.Format("%d\r\n",tmpInt & 0xffff);
			saveStr += tmpStr;
		}	
		WriteFile(h_SAVEFILE_T,saveStr,saveStr.GetLength(),&stLeng,NULL);
	}while(stLeng);
    
	CloseHandle(h_OPENFILE_B);
	CloseHandle(h_SAVEFILE_T);

	MessageBox("ϊI܂","bZ[W",MB_OK);
}

void CDevForm::OnEditchangeClockSrc() 
{
	Check_ClockSetting();
}

void CDevForm::Check_ClockSetting()
{
	double tmpClk;
	UpdateData(TRUE);

	ClkSrc = m_ClockSrc;
	if( ClkSrc == 5 )
	{
		m_IntClkFreq = "";
	}
	else
	{
		switch(ClkSrc)
		{
		case 0://200MHz
			tmpClk = 200.0;
			break;
		case 1://20.48MHz
			tmpClk = 20.48;
			break;
		case 2://16.384MHz
			tmpClk = 16.384;
			break;
		case 3://12.8MHz
			tmpClk = 12.8;
			break;
		case 4://1.92MHz
			tmpClk = 1.92;
			break;
		}

		ClkDivN = m_DivideN;
		if(ClkDivN != 0 )//0łȂ
		{
			tmpClk /= ClkDivN;
			if( tmpClk > 25.0 || tmpClk <= 1.0 )//NbN1`25MHzłȂ΂ȂȂ
			{
				m_IntClkFreq = "Out of Range";
			}
			else
			{
				SmplAve = m_AverageN;
				tmpClk = tmpClk / (1 << SmplAve );
				if( tmpClk >= 1.0 )
				{
					m_IntClkFreq.Format("%06.4f MHz",tmpClk);
				}
				else
				{
					m_IntClkFreq.Format("%06.3f kHz",tmpClk*1000.0);
				}
			}
		}
		else
			m_IntClkFreq = "Invalid value";
	}
	UpdateData(FALSE);
}


void CDevForm::OnEditchangeAverageN() 
{
	Check_ClockSetting();	
}

void CDevForm::OnSelchangeClockSrc() 
{
	Check_ClockSetting();	
}

void CDevForm::OnSelchangeAverageN() 
{
	Check_ClockSetting();	
}
