
#ifdef TUSBADMH_EXPORTS
#define TUSBADMH_API __declspec(dllexport)
#else
#define TUSBADMH_API __declspec(dllimport)
#endif


#ifdef __cplusplus
extern "C"{
#endif

	TUSBADMH_API void __stdcall Tusbadmh_Load(void);
	TUSBADMH_API void __stdcall Tusbadmh_Unload(void);
	TUSBADMH_API short __stdcall Tusbadmh_Chk(short Id);
	TUSBADMH_API short __stdcall Tusbadmh_Dio_Read(short Id,BYTE *Data);
	TUSBADMH_API short __stdcall Tusbadmh_Dio_Write(short Id,BYTE Data);
	TUSBADMH_API  short __stdcall Tusbadmh_Adc_Start(short Id,int CycLen, int PreLen,BYTE TrgSel,BYTE Mode,BYTE Ch1Only);
	TUSBADMH_API  short __stdcall Tusbadmh_Adc_Stop(short Id );
	TUSBADMH_API  short __stdcall Tusbadmh_Status_Get(short Id ,BYTE *Status,BYTE *OvfSt);
	TUSBADMH_API  short __stdcall Tusbadmh_Length (short Id,int *Len1, int *Len2,int *Rate1,int *Rate2);
	TUSBADMH_API  short __stdcall Tusbadmh_Data_Get(short Id,BYTE ch,int *Data,int *Leng);
	TUSBADMH_API  short __stdcall Tusbadmh_Clock_Select(short Id ,BYTE ClkSel, BYTE Div, BYTE Ave);
	TUSBADMH_API  short __stdcall Tusbadmh_ThLevel_Set (short Id ,int ThLevel, int NLevel);
	TUSBADMH_API  short __stdcall Tusbadmh_InputType(short Id ,BYTE Type1,BYTE Type2);
	TUSBADMH_API  short __stdcall Tusbadmh_CheckInputType(short Id ,BYTE *Type1,BYTE *Type2);
	TUSBADMH_API  short __stdcall Tusbadmh_Trigger (short Id );

#ifdef __cplusplus
}
#endif



