VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form MainForm 
   BorderStyle     =   1  'Œ()
   Caption         =   "TUSB-0216ADMHTvvO"
   ClientHeight    =   1515
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   5175
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1515
   ScaleWidth      =   5175
   StartUpPosition =   3  'Windows ̊l
   Begin VB.CommandButton FileConvBtn 
      Caption         =   "BinFile -> TextFile"
      Height          =   855
      Left            =   4080
      TabIndex        =   1
      Top             =   240
      Width           =   975
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   240
      Top             =   360
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Left            =   840
      Top             =   360
   End
   Begin VB.CommandButton EndAppBtn 
      Caption         =   "I"
      Height          =   615
      Left            =   1560
      TabIndex        =   0
      Top             =   600
      Width           =   1935
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-----------------------------------------------
'TUSB-0216ADMH Sample Program
'Visual Basic 6 Source codes
'
'Sep. 13 2010
'Copyright (C) 2010 Turtle Industry Co.,Ltd.
'-----------------------------------------------
Private DevStatus(15) As Boolean ' Device Connection Flag TRUE : connecting
Private IdDevForm(15) As Form ' Device Control Panel Form Object

Private Sub EndAppBtn_Click()
    Unload Me
End Sub

't@Cϊ@\
'poCit@CJ}؂eLXg`(CSV)ɕϊ
Private Sub FileConvBtn_Click()
    Dim CurPath As String
    On Error GoTo CancelError
    Dim BinFileName As String
    Dim TxtFileName As String
    Dim BinFileNum As Integer
    Dim TxtFileNum As Integer
    
    CurPath = App.Path
    
    Do
        CommonDialog1.FileName = ""
        CommonDialog1.DialogTitle = "oCit@Cw"
        CommonDialog1.Filter = "oCit@C (*.dat)|*.dat|"
        CommonDialog1.CancelError = True
        CommonDialog1.Flags = CommonDialog1.Flags Or FileOpenConstants.cdlOFNFileMustExist
        CommonDialog1.ShowOpen
    Loop While CommonDialog1.FileName = ""
    BinFileName = CommonDialog1.FileName
    
    Do
        CommonDialog1.FileName = ""
        CommonDialog1.DialogTitle = "ϊt@Cw"
        CommonDialog1.Filter = "eLXgۑt@C (*.csv)|*.csv|"
        CommonDialog1.CancelError = True
        CommonDialog1.Flags = CommonDialog1.Flags Or FileOpenConstants.cdlOFNOverwritePrompt
        CommonDialog1.ShowSave
    Loop While CommonDialog1.FileName = ""
    TxtFileName = CommonDialog1.FileName
    
    BinFileNum = FreeFile
    Open BinFileName For Binary As #BinFileNum
    
    TxtFileNum = FreeFile
    Open TxtFileName For Output As #TxtFileNum
    
    Dim DateTime As Date '
    Dim tmpByte As Byte
    Dim tmpInt As Integer
    Dim tmpLng As Long
    
    Get #BinFileNum, , DateTime '
    Write #TxtFileNum, "Start date time", DateTime
    Get #BinFileNum, , tmpByte 'ch
    Write #TxtFileNum, "Channel", tmpByte
    
    Get #BinFileNum, , tmpByte 'NbN
    Write #TxtFileNum, "Clock select", Choose(tmpByte + 1, _
            "200MHz", "20.48MHz", "16.384MHz", "12.8MHz", "1.92MHz", "External")
    Get #BinFileNum, , tmpByte 'NbN
    Write #TxtFileNum, "Dividing rate", tmpByte
    Get #BinFileNum, , tmpByte 'TvOω搔
    Write #TxtFileNum, "Average Cnt", CStr(2 ^ tmpByte)
    Get #BinFileNum, , tmpByte 'W 1:j|[@0:oC|[
    Write #TxtFileNum, "Input range", IIf(tmpByte = 1, "Unipolar", "Bipolar")
    Get #BinFileNum, , tmpByte 'gKI 0:O 1:オ 2: 3:\tgEFA
    Write #TxtFileNum, "Trigger select", Choose(tmpByte + 1, "External", "Up edge", _
                                                        "Down edge", "Software")
    Get #BinFileNum, , tmpLng 'AiOgK臒l
    Write #TxtFileNum, "Trigger threshold", tmpLng
    Get #BinFileNum, , tmpLng 'mCYLZx
    Write #TxtFileNum, "Noise cancel level", tmpLng
    Get #BinFileNum, , tmpByte '荞ݓ샂[h 0:A 1:s[g
    Write #TxtFileNum, "Sampling mode", IIf(tmpByte = 0, "Continuation", "Repeat")
    Get #BinFileNum, , tmpLng '1gK̎荞ݒ
    Write #TxtFileNum, "Sampling length per one trigger", tmpLng
    Get #BinFileNum, , tmpLng 'vgK
    Write #TxtFileNum, "Pre trigger length", tmpLng
    
    
    Do While Not EOF(BinFileNum)
        Get #BinFileNum, , tmpLng
        If Not EOF(BinFileNum) Then
           Write #TxtFileNum, tmpLng And &HFFFF
        End If
    Loop
    
    Close #BinFileNum
    Close #TxtFileNum
    
    MsgBox ("ϊI܂")
    
CancelError:
    ChDir (CurPath)
End Sub

' Main Form Load
Private Sub Form_Load()
    Dim DevId As Integer
    
    Tusbadmh_Load 'Driver Load
    
    'Initialize
    For DevId = 0 To 15
        DevStatus(DevId) = False 'Device is not Connected
        Set IdDevForm(DevId) = New DevForm 'Device Control Panel Form Create
        Load IdDevForm(DevId) ' Device Control Panel Load
    Next DevId
    
    ' Timer Start
    Timer1.Interval = 500
    Timer1.Enabled = True
End Sub

' Main Form Unload ( Program exit )
Private Sub Form_Unload(Cancel As Integer)
    Dim DevId As Integer
    
    Timer1.Enabled = False ' Timer Disable
    
    For DevId = 0 To 15
        Unload IdDevForm(DevId) ' Device Control Panel Unload
    Next DevId
    
    Tusbadmh_Unload ' Driver Unload
End Sub

' Device Control Panel Open
Private Sub OpenPanel(ByVal Id As Integer)
    IdDevForm(Id).SetId (Id)
    IdDevForm(Id).Show ' Form Show
    DevStatus(Id) = True
End Sub

' Timer Handler
Private Sub Timer1_Timer()
    Dim DevId As Integer
    
    For DevId = 0 To 15
        If DevStatus(DevId) = False Then ' Device is not connected
            If Tusbadmh_Chk(DevId) = 0 Then ' Connection check
                OpenPanel DevId '
            End If
        Else 'Device is connected
            If IdDevForm(DevId).Visible = False Then ' Device is not visible
                DevStatus(DevId) = False
            End If
        End If
    Next DevId
End Sub

