Attribute VB_Name = "TUSBADMH"
'*******   High speed A/D converter TUSB-0216ADMH   ******
'         Control Module File for Visual Basic

Declare Sub Tusbadmh_Load Lib "TUSBADMH.DLL" ()
Declare Sub Tusbadmh_Unload Lib "TUSBADMH.DLL" ()
Declare Function Tusbadmh_Chk Lib "TUSBADMH.DLL" (ByVal Id As Integer) As Integer
Declare Function Tusbadmh_Dio_Read Lib "TUSBADMH.DLL" (ByVal Id As Integer, ByRef Data As Byte) As Integer
Declare Function Tusbadmh_Dio_Write Lib "TUSBADMH.DLL" (ByVal Id As Integer, ByVal Data As Byte) As Integer
Declare Function Tusbadmh_Adc_Start Lib "TUSBADMH.DLL" (ByVal Id As Integer, ByVal CycLen As Long, ByVal PreLen As Long, _
                                                        ByVal TrgSel As Byte, ByVal Mode As Byte, ByVal Ch1Only As Byte) As Integer
Declare Function Tusbadmh_Adc_Stop Lib "TUSBADMH.DLL" (ByVal Id As Integer) As Integer
Declare Function Tusbadmh_Status_Get Lib "TUSBADMH.DLL" (ByVal Id As Integer, ByRef Status As Byte, _
                                                        ByRef OvfSt As Byte) As Integer
Declare Function Tusbadmh_Length Lib "TUSBADMH.DLL" (ByVal Id As Integer, ByRef Len1 As Long, _
                                                        ByRef Len2 As Long, ByRef Rate1 As Long, _
                                                        ByRef Rate2 As Long) As Integer
Declare Function Tusbadmh_Data_Get Lib "TUSBADMH.DLL" (ByVal Id As Integer, ByVal ch As Byte, _
                                                        ByRef Data As Long, ByRef Leng As Long) As Integer
Declare Function Tusbadmh_Clock_Select Lib "TUSBADMH.DLL" (ByVal Id As Integer, ByVal ClkSel As Byte, _
                                                        ByVal Div As Byte, ByVal Ave As Byte) As Integer
Declare Function Tusbadmh_ThLevel_Set Lib "TUSBADMH.DLL" (ByVal Id As Integer, ByVal ThLevel As Long, ByVal NLevel As Long) As Integer
Declare Function Tusbadmh_InputType Lib "TUSBADMH.DLL" (ByVal Id As Integer, ByVal Type1 As Byte, _
                                                        ByVal Type2 As Byte) As Integer
Declare Function Tusbadmh_CheckInputType Lib "TUSBADMH.DLL" (ByVal Id As Integer, ByRef Type1 As Byte, _
                                                        ByRef Type2 As Byte) As Integer
Declare Function Tusbadmh_Trigger Lib "TUSBADMH.DLL" (ByVal Id As Integer) As Integer

'Tusbadmh_Clock_Select

' Error Message
Public Function Tusbadmh_ErrorDisp(ByVal ErrCode As Integer)
    Dim tmpStr As String
    
    Select Case ErrCode
    Case 0
        tmpStr = "ɏI܂"
    Case 1
        tmpStr = "IDԍ܂"
    Case 2
        tmpStr = "hCoĂ܂"
    Case 4
        tmpStr = "ڑĂ䐔܂"
    Case 5
        tmpStr = "I[vł܂ł"
    Case 6
        tmpStr = "foCX܂ł"
    Case 7
        tmpStr = "w̃foCX̓I[vĂ܂"
    Case 8
        tmpStr = "p[^G["
    Case 9
        tmpStr = "USBʐMG["
    Case 10
        tmpStr = "̈悪mۂł܂"
    Case 11
        tmpStr = "A捞쒆ł"
    Case 12
        tmpStr = "A荞݃f[^͂܂"
    Case 13
        tmpStr = "JnĂ܂"
    Case 14
        tmpStr = "I[o[t["
    Case 15
        tmpStr = "f[^уG["
    Case Default
        tmpStr = "sȃG[ł"
    End Select
    
    MsgBox (tmpStr)
End Function


